package app;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.Signature;

import biz.source_code.base64Coder.Base64Coder;

public class TestDSA {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		/* Generate a DSA signature */
		
      try {

        /* Generate a key pair */

        KeyPairGenerator keyGen = KeyPairGenerator.getInstance("DSA",
            "SUN");
        SecureRandom random = SecureRandom.getInstance("SHA1PRNG",
            "SUN");

        keyGen.initialize(1024, random);

        KeyPair pair = keyGen.generateKeyPair();
        PrivateKey priv = pair.getPrivate();
        PublicKey pub = pair.getPublic();

        /*
         * Create a Signature object and initialize it with the private
         * key
         */

        Signature dsa = Signature.getInstance("SHA1withDSA", "SUN");

        dsa.initSign(priv);

        dsa.update("asfs".getBytes());
        
        /*
         * Now that all the data to be signed has been read in, generate
         * a signature for it
         */

        byte[] realSig = dsa.sign();
        System.out.println(Base64Coder.encode(realSig));
        

        /* Save the signature in a file */
        FileOutputStream sigfos = new FileOutputStream("sig.txt");
        sigfos.write(realSig);

        sigfos.close();

        /* Save the public key in a file */
        byte[] key = pub.getEncoded();
        System.out.println(Base64Coder.encode(key));
        System.out.println(Base64Coder.encode(key).length);
        
        FileOutputStream keyfos = new FileOutputStream("suepk.txt");
        keyfos.write(key);

        keyfos.close();

      } catch (Exception e) {
        System.err.println("Caught exception " + e.toString());
      }

	}

}
