package app;

import java.math.BigInteger;
import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.Security;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.RSAPrivateKeySpec;
import java.security.spec.RSAPublicKeySpec;
import java.security.spec.X509EncodedKeySpec;

import javax.crypto.Cipher;

import biz.source_code.base64Coder.Base64Coder;

public class TestRSA {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub

//	    byte[] input = new byte[] { (byte) 0xbe, (byte) 0xef };
	    byte[] input = ("ala ma kotkassdfs").getBytes("UTF-8");
	    Cipher cipher = Cipher.getInstance("RSA/ECB/OAEPWithSHA1AndMGF1Padding");

	    KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
        kpg.initialize(2048);
        KeyPair kp = kpg.genKeyPair();
        RSAPublicKey pubKey = (RSAPublicKey) kp.getPublic();
        RSAPrivateKey privKey = (RSAPrivateKey) kp.getPrivate();
//        KeyFactory fact = KeyFactory.getInstance("RSA");        
//        RSAPublicKeySpec pub = fact.getKeySpec(kp.getPublic(), RSAPublicKeySpec.class);
//        RSAPrivateKeySpec priv = fact.getKeySpec(kp.getPrivate(), RSAPrivateKeySpec.class);

        System.out.println("PUBLIC");
        System.out.println(Base64Coder.encode(pubKey.getEncoded()));
        
        
        
        X509EncodedKeySpec ks = new X509EncodedKeySpec(pubKey.getEncoded());
        KeyFactory kf = KeyFactory.getInstance("RSA");
        RSAPublicKey pubKey2 = (RSAPublicKey) kf.generatePublic(ks);
        System.out.println("PUBLIC RECOVERED");
        System.out.println(Base64Coder.encode(pubKey2.getEncoded()));
        
        System.out.println("PRIVATE");
        System.out.println(Base64Coder.encode(privKey.getEncoded()));

        PKCS8EncodedKeySpec privateKeySpec = new PKCS8EncodedKeySpec(privKey.getEncoded());
        KeyFactory kf2 = KeyFactory.getInstance("RSA");
        RSAPrivateKey privKey2 = (RSAPrivateKey) kf2.generatePrivate(privateKeySpec);
        System.out.println("PRIVATE RECOVERED");
        System.out.println(Base64Coder.encode(privKey2.getEncoded()));
        
	    cipher.init(Cipher.ENCRYPT_MODE, pubKey);

	    
	    byte[] cipherText = cipher.doFinal(input);
	    System.out.println("ENCRYPTED MESSAGE");
	    System.out.println(Base64Coder.encode(cipherText));
	    

	    cipher.init(Cipher.DECRYPT_MODE, privKey);
	    byte[] plainText = cipher.doFinal(cipherText);
	    System.out.println("plain : " + new String(plainText));
	}

}
