package budrys.social;

import java.util.Hashtable;
import java.util.Iterator;
import org.jsonb.JSONArray;
import org.jsonb.JSONException;
import org.jsonb.JSONObject;

import budrys.security.Crypt;

public class FriendsModel {
	private Hashtable<String, ProfileModel> friends;

	public FriendsModel() {
		friends = new Hashtable<String, ProfileModel>();
	}
	
	public FriendsModel(String json) {
		friends = new Hashtable<String, ProfileModel>();
		importFromJson(json);
	}
	
	public void addFriend(String key, ProfileModel pm){
		pm.setFromCache(true);
		friends.put(key, pm);
	}
	
	public void removeFriend(String key){
		friends.remove(key);
	}
	
	public Iterator<ProfileModel> enumFriends(){
		return friends.values().iterator();
	}
	
	public boolean isFriend(String key){
		return friends.containsKey(key);
	}
	
	public ProfileModel getFriend(String key){
		return friends.get(key);
	}
	
	public boolean updateFriend(String key, ProfileModel pm){
		ProfileModel oldValue = friends.put(key, pm);
		if (oldValue==null){
			return false;
		}
		return true;
	}

	public boolean importFromJson(String json) {
		JSONObject decode = new JSONObject();
		// FRIENDS LIST
		friends = new Hashtable<String, ProfileModel>();
		JSONArray jb;
		try {
			decode = new JSONObject(json);
			if (decode.has("friends")){
				jb = decode.getJSONArray("friends");
				for (int i=0; i<jb.length(); ++i){
					JSONObject jo = jb.getJSONObject(i);
					ProfileModel pm = new ProfileModel(jo.toString());
					if (pm.getPublicKey()!=null){
						addFriend(Crypt.encodeKey(pm.getPublicKey()), pm);
//						friends.put(Crypt.encodeKey(pm.getPublicKey()), pm);					
					} else {
						// DO NOT PUT FRIENDS WITHOUT PUBLIC KEY
						// WITHOUT A PUBLIC KEY YOU CANNOT IDENTIFY THE PERSON
					}
				}
			}
		} catch (JSONException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}

	public JSONObject exportAllToJson() {
		JSONObject json = new JSONObject();
		try {
			Iterator<ProfileModel> it = friends.values().iterator();
			while (it.hasNext()){
				ProfileModel pm = it.next();
				json.append("friends", pm.exportAllToJson());
			}
		} catch (JSONException e1) {
			e1.printStackTrace();
		}
		return json;
	}
	
	public String toString(){
		super.toString();
		return exportAllToJson().toString();
	}
}
